--+ KET 9/13/89 modified to correct Eilers #1
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_in_int_00 IS
 
  tasking_flag : boolean;
 
  -- pragma suppress(access_check);
  -- pragma suppress(discriminant_check);
  -- pragma suppress(index_check);
  -- pragma suppress(length_check);
  -- pragma suppress(range_check);
  -- pragma suppress(division_check);
  -- pragma suppress(overflow_check);
  -- pragma suppress(elaboration_check);
  -- pragma suppress(storage_check);
 
  TASK time_task IS
 
  END time_task;
 
  TASK reg_task IS
 
    ENTRY receive;
 
  END reg_task;
 
  TASK BODY reg_task IS
  BEGIN
    LOOP
 
    --+ KET 9/13/89 modified to correct Eilers #1
    --+             moved setting of TASKING_FLAG inside rendezvous
 
      ACCEPT receive DO
        tasking_flag := true;
      END receive;
    END LOOP;
  END reg_task;
 
 
  TASK BODY time_task IS
  BEGIN
    --
    -- Test Name         :  tk_in_int_00
    -- Prime Purpose     :  Timing of a simple task.  No interrupt is raised in
    --                      this test.  It is used for purposes of comparison.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related Tests     :  tk_in_int_01
    -- Author            :  Maralee Turner
    -- Reviewer          :  T. Leavitt, 11-oct-89
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_in_int_00");

    PRAGMA include("startime");

    tasking_flag := false;
    reg_task.receive;
    WHILE NOT tasking_flag LOOP
      NULL;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional
		("   - Timing of a simple task.  No interrupt is raised in");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
		("   This test.  It is used for purposes of comparison.");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
    ABORT reg_task;
  END time_task;
 
BEGIN
  NULL;
END tk_in_int_00;
