WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_ls22 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  PROCEDURE proca IS
    TASK t1 IS
      ENTRY call1;
    END t1;
 
    TASK BODY t1 IS
    BEGIN
      SELECT
        ACCEPT call1;
      OR
        TERMINATE;    -- selected option
      END SELECT;
    END t1;
 
    TASK t2 IS
    END t2;
 
    TASK BODY t2 IS
    BEGIN
      IF zg_glob4.ll = 3 THEN
        t1.call1;
        -- die;
      END IF;
    END t2;
 
  BEGIN
    NULL;
  END proca;
 
BEGIN
  
  --
  -- Test Name         :  tk_ls_task_46
  -- Prime Purpose     :  Task with a terminate option which is taken.
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Kermit Terrell
  -- Reviewer          :  T. Leavitt, 12-oct-89
  -- Date              :  Written 22 July 1987.
  -- Source            :  -
  -- Dependencies      :  -
  -- Other Information :
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_ls_task_46");

  PRAGMA include("startime");

  proca;

  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional("   task that takes the terminate option");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      SELECT           ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("         ACCEPT call1; ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      OR               ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("         TERMINATE;     -- selected option");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      END SELECT;      ");
  zg_glob2.put_new_line_optional;

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
  
  zg_glob4.ll := 3;
 
  --
  -- Test Name         :  tk_ls_task_46x
  -- Prime Purpose     :  Task with a terminate option which is not taken.
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Kermit Terrell
  -- Reviewer          :  T. Leavitt, 12-oct-89
  -- Date              :
  --                      Written 22 July 1987.
  -- Source            :  -
  -- Dependencies      :  -
  -- Other Information :
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_ls_task_46x");

  PRAGMA include("startime");

  proca;

  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional("   task that does NOT take the terminate option");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      SELECT");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("         ACCEPT call1;     -- selected option");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      OR ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("         TERMINATE;    ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      END SELECT;      ");
  zg_glob2.put_new_line_optional;

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
  
END tk_ls22;
