with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
with calendar;
use  calendar;

procedure tk_rz_task_hundred_parameter is

pragma suppress(access_check);
pragma suppress(discriminant_check);
pragma suppress(index_check);
pragma suppress(length_check);
pragma suppress(range_check);
pragma suppress(division_check);
pragma suppress(overflow_check);
pragma suppress(elaboration_check);
pragma suppress(storage_check);

pragma OPTIMIZE (TIME);

   -- Accepts a simple rendezvous (one with no parameters).

   run_tot : zg_glob1.integer16 := 0 ;

   procedure NO_OP (I : zg_glob1.integer16 ; J : in out  zg_glob1.integer16 ) is
   begin
      if not zg_glob3.boolean_false then
         J := 0;
      else  -- Never executed.
         J := I - J - 1;
      end if;
      RUN_TOT := J;
   exception
      when NUMERIC_ERROR | CONSTRAINT_ERROR =>  -- Never executed.
         raise PROGRAM_ERROR ;
   end NO_OP;

   task HUNDRED_ACCEPTOR is
      entry STARTUP;
      entry E (I1,  I2,  I3,  I4,  I5,  I6,  I7,  I8,  I9,  I10,
               I11, I12, I13, I14, I15, I16, I17, I18, I19, I20,
               I21, I22, I23, I24, I25, I26, I27, I28, I29, I30,
               I31, I32, I33, I34, I35, I36, I37, I38, I39, I40,
               I41, I42, I43, I44, I45, I46, I47, I48, I49, I50,
               I51, I52, I53, I54, I55, I56, I57, I58, I59, I60,
               I61, I62, I63, I64, I65, I66, I67, I68, I69, I70,
               I71, I72, I73, I74, I75, I76, I77, I78, I79, I80,
               I81, I82, I83, I84, I85, I86, I87, I88, I89, I90,
               I91, I92, I93, I94, I95, I96, I97, I98, I99, I100 
             : zg_glob1.integer16 );
      entry FINISH;
   end HUNDRED_ACCEPTOR;

   -- hundred_caller in a simple rendezvous.

   task HUNDRED_CALLER is
      entry STARTUP;
      entry FINISH ; 
   end HUNDRED_CALLER;

   task body HUNDRED_ACCEPTOR is
   begin
      loop
         accept STARTUP;
         for I in zg_glob1.integer16'(1) .. zg_glob1.integer16'(1000) 
         loop
           NO_OP (I, RUN_TOT);
           accept E (I1,  I2,  I3,  I4,  I5,  I6,  I7,  I8,  I9,  I10,
                     I11, I12, I13, I14, I15, I16, I17, I18, I19, I20,
                     I21, I22, I23, I24, I25, I26, I27, I28, I29, I30,
                     I31, I32, I33, I34, I35, I36, I37, I38, I39, I40,
                     I41, I42, I43, I44, I45, I46, I47, I48, I49, I50,
                     I51, I52, I53, I54, I55, I56, I57, I58, I59, I60,
                     I61, I62, I63, I64, I65, I66, I67, I68, I69, I70,
                     I71, I72, I73, I74, I75, I76, I77, I78, I79, I80,
                     I81, I82, I83, I84, I85, I86, I87, I88, I89, I90,
                     I91, I92, I93, I94, I95, I96, I97, I98, I99, I100
                   : zg_glob1.integer16  )
           do
             if zg_glob3.boolean_false then 
               zg_glob4.ii := 
                   I1  + I2  + I3  + I4  + I5  + I6  + I7  + I8  + I9  + I10 +
                   I11 + I12 + I13 + I14 + I15 + I16 + I17 + I18 + I19 + I20 +
                   I21 + I22 + I23 + I24 + I25 + I26 + I27 + I28 + I29 + I30 +
                   I31 + I32 + I33 + I34 + I35 + I36 + I37 + I38 + I39 + I40 +
                   I41 + I42 + I43 + I44 + I45 + I46 + I47 + I48 + I49 + I50 +
                   I51 + I52 + I53 + I54 + I55 + I56 + I57 + I58 + I59 + I60 +
                   I61 + I62 + I63 + I64 + I65 + I66 + I67 + I68 + I69 + I70 +
                   I71 + I72 + I73 + I74 + I75 + I76 + I77 + I78 + I79 + I80 +
                   I81 + I82 + I83 + I84 + I85 + I86 + I87 + I88 + I89 + I90 +
                   I91 + I92 + I93 + I94 + I95 + I96 + I97 + I98 + I99 + I100 ;
               zg_glob4.proci1 ( zg_glob4.ii );
               zg_glob4.die;                -- for consistency
             end if;
           end;
         end loop;
         accept FINISH;
      end loop;
   end HUNDRED_ACCEPTOR;

  task body HUNDRED_CALLER is
  begin
    loop
      accept STARTUP;
      HUNDRED_ACCEPTOR.STARTUP;
      for i in zg_glob1.integer16'(1) .. zg_glob1.integer16'(1000) 
      loop
        NO_OP (I, RUN_TOT);
        HUNDRED_ACCEPTOR.E (
           I+ 0, I+ 1, I+ 2, I+ 3, I+ 4, I+ 5, I+ 6, I+ 7, I+ 8, I+ 9, 
           I+10, I+11, I+12, I+13, I+14, I+15, I+16, I+17, I+18, I+19, 
           I+20, I+21, I+22, I+23, I+24, I+25, I+26, I+27, I+28, I+29, 
           I+30, I+31, I+32, I+33, I+34, I+35, I+36, I+37, I+38, I+39, 
           I+40, I+41, I+42, I+43, I+44, I+45, I+46, I+47, I+48, I+49, 
           I+50, I+51, I+52, I+53, I+54, I+55, I+56, I+57, I+58, I+59, 
           I+60, I+61, I+62, I+63, I+64, I+65, I+66, I+67, I+68, I+69, 
           I+70, I+71, I+72, I+73, I+74, I+75, I+76, I+77, I+78, I+79, 
           I+80, I+81, I+82, I+83, I+84, I+85, I+86, I+87, I+88, I+89, 
           I+90, I+91, I+92, I+93, I+94, I+95, I+96, I+97, I+98, I+99);
        RUN_TOT := I;
      end loop;
      accept FINISH ;
    end loop;
   end HUNDRED_CALLER;

begin           -- of main program

  -- Test Name         :  tk_rz_task_hundred_parameter 
  -- Prime Purpose     :  Fourth of 4 tests which explore the effect of passing 
  --                      increasing numbers of parameters. This test passes
  --                      one hundred integer parameters. 
  -- Optimization      :  
  -- Related tests     :  tk_rz_task_no_parameter, tk_rz_task_one_parameter,
  --                      tk_rz_task_ten_parameters 
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  B. Decker-Lindsey  -  1 April 1992
  -- Date              :  19 March 1992
  -- Source            :  AES Test TL15, fourth case
  -- Dependencies      :  
  -- Other Information :  

   zg_glob2.put_test_name("tk_rz_task_hundred_parameter ");

   pragma include("startime");
     HUNDRED_CALLER.STARTUP;
     HUNDRED_CALLER.FINISH ;
     HUNDRED_ACCEPTOR.FINISH;
   pragma include("stoptime0");
     zg_glob2.put_comment_optional(
     "   Fourth of 4 tests which explore the effect of varying numbers of");
     zg_glob2.put_new_line_optional;
     zg_glob2.put_comment_optional(
     "   parameters on rendezvous speed. This test passes one hundred ");
     zg_glob2.put_new_line_optional;
     zg_glob2.put_comment_optional(
     "   parameters.  Test performs 1000 simple rendezvous plus 3 for setup. ");
   pragma include ("stoptime2");

   abort hundred_caller, hundred_acceptor;

end tk_rz_task_hundred_parameter ;
