WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_eh_except_handl_04 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  excp : EXCEPTION;

  PROCEDURE f IS
  BEGIN
    zg_glob4.proc0;
    IF zg_glob4.ii > 0 THEN
      RAISE excp;
    END IF;
  END f;

  PROCEDURE g1 IS
  BEGIN
    zg_glob4.xx := zg_glob4.one;
    f;
  EXCEPTION
    WHEN numeric_error | constraint_error =>
      zg_glob4.die;
    WHEN OTHERS =>
      RAISE ;
  END g1;

  PROCEDURE h1 IS
  BEGIN
    g1;
  EXCEPTION
    WHEN excp =>
      NULL;
    WHEN OTHERS =>
      zg_glob4.die;
  END h1;


BEGIN
  --
  -- Test Name         :  xh_eh_except_handl_04
  -- Prime Purpose     :  make two procedure calls. The lowest level has an
  --                      exception handler which can (re) raise an exception
  --                      and propagate it to the next higher level. This
  --                      problem does NOT raise the exception.
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :  xh_eh_except_handl_01
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Thomas M. Lee
  -- Date              :  October 13, 1989
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 

  zg_glob4.ii := -100;     -- this causes exception NOT to be raised
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_eh_except_handl_04");
  PRAGMA include("startime");
  h1;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   h1;   -- cf xh_eh_except_handl_01, exception not propagated");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------

END xh_eh_except_handl_04;  
