WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_en_except_num_err_01 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  --
  -- Test Name         :  xh_en_except_num_err_01
  -- Prime Purpose     :  does not define exception
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :  xh_er_except_raise_02, xh_er_except_raise_03
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Thomas M. Lee
  -- Date              :  October 13, 1989
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
   
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_en_except_num_err_01");
  PRAGMA include("startime");
  DECLARE                                -- cf xh_er_except_raise_02 xh_er_except_raise_03
  BEGIN
    IF zg_glob4.ll < 0 THEN                       -- false, except not raised
      RAISE numeric_error;
    END IF;
  END;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   -- exception neither declared nor raised");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   DECLARE");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   BEGIN");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "     IF ll<0   THEN raise numeric_error;   END IF;   -- false, not raised");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   END;  -- cf xh_er_except_raise_02 xh_er_except_raise_03");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 

END xh_en_except_num_err_01 ;  
