WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
WITH xh_pdpkg;
USE xh_pdpkg;
 
PROCEDURE xh_pd_prgma_sup_discr_ck_02 IS

--no checking suppressed
  a20 : zg_glob3.vector(1 .. 20);

BEGIN
  --
  -- Test Name       :  xh_pd_prgma_sup_discr_ck_02
  -- Prime Purpose   :  language feature test, pass parameter to unconstrained
  --                    formal parameter. With checking enabled.
  -- LRM Version     :  Revision A
  -- Optimization    :
  -- Related tests   :  xh_pd_prgma_sup_discr_ck_05
  -- Author          :  Thomas C. Leavitt
  -- Reviewer        :  Thomas M. Lee
  -- Date            :
  -- Source          :
  -- Dependencies    :
  -- Other Information :
  --
 
 
  IF zg_glob4.ll /= zg_glob4.mm THEN
    xh_pdpkg.mike := (xh_pdpkg.single, "patrick   ", 1950, "none      ");
    xh_pdpkg.pat := (xh_pdpkg.married, "mike      ", 1900, "pat       ", 2);
  ELSE
    xh_pdpkg.pat := (xh_pdpkg.single, "patrick   ", 1950, "none      ");
    xh_pdpkg.mike := (xh_pdpkg.married, "mike      ", 1900, "pat       ", 2);
  END IF;
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_pd_prgma_sup_discr_ck_02");
  PRAGMA include("startime");
  xh_pdpkg.proc_vector(a20);
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   proc_vector(a20);  -- pass unconstrained array type");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   -- cf xh_pd_prgma_sup_discr_ck_05");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------

END xh_pd_prgma_sup_discr_ck_02;  
