WITH xh_pepkg02;
USE  xh_pepkg02;
WITH xh_pepkg03;
USE  xh_pepkg03;
WITH xh_pepkg04;
USE  xh_pepkg04;
WITH xh_pepkg05;
USE  xh_pepkg05;
WITH xh_pepkg06;
USE  xh_pepkg06;

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;

PACKAGE pkg01_xh_pe07 IS
  pragma Elaborate_Body;  -- Required by Ada 95.  PCR 2.32   DEC 94
 
                                  --  no objects or types are exported
END pkg01_xh_pe07;
 
PACKAGE BODY pkg01_xh_pe07 IS
  
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
 
  PRAGMA include("inittime"); --timing loop must be initialized here

  --
  -- Test Name         :  xh_pe_prgma_sup_elab_ck_07
  -- Prime Purpose     :  Version of xh_pe_prgma_sup_elab_ck_02 which 
  --                      specified suppression of predefined constraint 
  --                      checking.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :  xh_pe_prgma_sup_elab_ck_*
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_pe_prgma_sup_elab_ck_07");
  PRAGMA include("startime");
  BEGIN
    IF zg_glob4.ll /= zg_glob4.mm THEN    -- always true
      xh_pepkg02.elab_02;
      xh_pepkg03.elab_03;
      xh_pepkg04.elab_04;
      xh_pepkg05.elab_05;
      xh_pepkg06.elab_06;
    END IF;
  EXCEPTION
    WHEN program_error =>
      zg_glob4.die;
  END;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   --suppress checking version of xh_pe_prgma_sup_elab_ck_02 ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 
END pkg01_xh_pe07;
----------------------------------
 
WITH pkg01_xh_pe07;
USE  pkg01_xh_pe07;
PRAGMA elaborate(pkg01_xh_pe07);
 
PROCEDURE xh_pe_prgma_sup_elab_ck_07 IS
BEGIN
  NULL;    -- the actual test problem is contained in the package body
END xh_pe_prgma_sup_elab_ck_07;
