-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_lb_task_39

WITH zg_glob1;
PACKAGE pkg01_tk_lb03 IS
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
    ENTRY request;
    ENTRY release;
  END resource;
END pkg01_tk_lb03;
 
PACKAGE BODY pkg01_tk_lb03 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
END pkg01_tk_lb03;
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
 
WITH calendar;
USE  calendar;
WITH pkg01_tk_lb03;
USE  pkg01_tk_lb03;
WITH system;
 
PROCEDURE tk_lb_task_39 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END main;

 
  TASK BODY main IS
  BEGIN
 
    ABORT resource;
 
    --
    -- Test Name         :  tk_lb_task_39
    -- Prime Purpose     :  Language feature test of aspects of tasking.  This
    --                      program aborts a task which is already aborted.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lb_task_39");

    PRAGMA include("startime");

    ABORT resource;    -- already aborted

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("  abort resource;  -- already aborted");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
    --+ abort resource;-- stop execution --+ removed by KET, 19 Oct 1989
  END main;
 
BEGIN
  NULL;
END tk_lb_task_39;
