--  tk_lf_task_01 create and terminate a task

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_lf_task_01 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  PROCEDURE tasking IS
    TASK simple_task IS
    END simple_task;
 
    TASK BODY simple_task IS
    BEGIN
      NULL;    -- this is a very very simple task !
    END simple_task;
 
  BEGIN
    NULL;    -- this is a very simple procedure also
  END tasking;
 
 
BEGIN
 
  --
  -- Test Name         :  tk_lf_task_01
  -- Prime Purpose     :  language feature test, task creation and termination
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_lf_task_01");

  PRAGMA include("startime");
  FOR i IN 1 .. 10 LOOP
    tasking;    -- invoke procedure which creates and
                -- waits on null task
  END LOOP;
  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional("   FOR i IN 1..10");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   LOOP");  
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
		   ("      tasking; -- invoke procedure which creates and");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   END LOOP;    -- and waits on null task");

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
END tk_lf_task_01;
