-- tk_lf_task_02 , another simple test uses task types
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_lf_task_02 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  n : CONSTANT := 10;
 
  PROCEDURE tasking IS
    TASK TYPE simple_task IS   END simple_task;
 
  t1, t2, t3, t4, t5, t6, t7, t8, t9, t10 : simple_task;
 
  TASK BODY simple_task IS
  BEGIN
    NULL;
  END simple_task;
 
BEGIN    -- start of tasking
  NULL;
END tasking;
 
 
BEGIN
 
     
    --
    -- Test Name         :  tk_lf_task_02
    -- Prime Purpose     :  language feature test, task creation and termination
    --                      Uses a procedure which declares 10 tasks of the same
    --                      task type.  Implies synchronization with these tasks
    --                      to terminate the procedure.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
      
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lf_task_02");

    PRAGMA include("startime");

    FOR c IN 1 .. 10 LOOP
      tasking;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   FOR c IN 1..10");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("     LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("       tasking; -- uses task types, 10 tasks in tasking");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
END tk_lf_task_02;
