-- tk_lf_task_06 test attributes of tasks
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_lf_task_06 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK simple IS
  END simple;
 
  TASK BODY simple IS
  BEGIN
    LOOP
      DELAY 30.0;
    END LOOP;
  END simple;
 
BEGIN
 
  --
  -- Test Name         :  tk_lf_task_06
  -- Prime Purpose     :  Language feature test of aspects of tasking.
  --                      Tests access time to dynamic attributes.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_lf_task_06");

  PRAGMA include("startime");

  IF NOT simple'callable OR simple'terminated THEN
    zg_glob4.die;
  END IF;

  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional
	("   - if not simple'callable or simple'terminated then die; end if;");
  zg_glob2.put_new_line_optional;

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 
  ABORT simple;
END tk_lf_task_06;
