-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_rz_task_01_num_30 IS
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
  TASK TYPE resource IS 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
 
  t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14, t15, t16, t17,
   t18, t19, t20, t21, t22, t23, t24, t25, t26, t27, t28, t29, t30 : resource;
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
 
  TASK BODY main IS
  BEGIN
 
 
    --
    -- Test Name         :  tk_rz_task_01_num_30
    -- Prime Purpose     :  Test the performance of rendezvous when you vary
    --                      the number of tasks.  This test has 30.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related tests     :  tk_rz_task_01_num_25, tk_rz_task_01_num_20, 
    -- Related tests     :  tk_rz_task_01_num_15, tk_rz_task_01_num_10,
    -- Related tests     :  tk_rz_task_01_num_05, tk_rz_task_01_num_01
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_rz_task_01_num_30");

    PRAGMA include("startime");

    t1.request;
    t1.release;
    t2.request;
    t2.release;
    t3.request;
    t3.release;
    t4.request;
    t4.release;
    t5.request;
    t5.release;
    t6.request;
    t6.release;
    t7.request;
    t7.release;
    t8.request;
    t8.release;
    t9.request;
    t9.release;
    t10.request;
    t10.release;
    t11.request;
    t11.release;
    t12.request;
    t12.release;
    t13.request;
    t13.release;
    t14.request;
    t14.release;
    t15.request;
    t15.release;
    t16.request;
    t16.release;
    t17.request;
    t17.release;
    t18.request;
    t18.release;
    t19.request;
    t19.release;
    t20.request;
    t20.release;
    t21.request;
    t21.release;
    t22.request;
    t22.release;
    t23.request;
    t23.release;
    t24.request;
    t24.release;
    t25.request;
    t25.release;
    t26.request;
    t26.release;
    t27.request;
    t27.release;
    t28.request;
    t28.release;
    t29.request;
    t29.release;
    t30.request;
    t30.release;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   60 entry calls 30 different tasks ");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
    --+ TJT 09-15-89 Modified to correct Eilers #6
    --+time_num_30 := ( min_time * 1_000_000.0 / 60.0 );
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_rz_task_01_num_30 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1_000_000.0 / 60.0), 8, 1, 0);
    zg_glob2.put_new_line;
		----------------------------------------------------
 
    ABORT t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14, t15, t16,
     t17, t18, t19, t20, t21, t22, t23, t24, t25, t26, t27, t28, t29, t30;
 
  END main;
 
BEGIN
  NULL;
  --+ KET modified during review 19 Oct 1989
  --+ exception
  --+ when others =>
  --+ TJT 09-15-89 Modified to correct Eilers #6
  --+  time_num_30 := -1.0; -- failed, probably due to storage error
  --+  null;                   --+ TJT 09-15-89 Modified to correct Eilers #6
END tk_rz_task_01_num_30;
