-- User-defined benchmark template for ACES

-- Comments beginning with --:: are instructions.

-- Comments beginning with -->> indicate where you may insert parts or all
-- of your code.

--:: In the several occurences of "ud_a%_user_def_ada%#_??, replace the pair
--:: "%#" with  either "95" (if your test uses Ada 95 features)
--::           or      "83" (if your test is compatible with Ada 83).

--:: Replace the symbol '%' with either '9' or '8', consistent with your
--:: substitution for "%#".

--:: Replace the pair "??" with a two-digit representation of an integer in the
--:: range 1..10, using a leading zero as needed to make up the two digits.

--:: Change the name of this file to "ud_a%??_.inc", using the same 
--:: substitutions.

--:: To run your test as a part of the full ACES, use the Harness, select 
--:: the User_Defined test group, enter the Show Tests command, and select 
--:: the test by name.  (Be sure to watch out for the similarity in test 
--:: names between the Ada 83 and Ada 95 subgroups.)

-->> Insert library units required for the test code.

--:: Library units not in this file may be referenced only if you have
--:: "manually" compiled them into the library.  That is, the automated
--:: ACES test process will only compile this file.

with ZG_Glob1;
use  ZG_Glob1;
with ZG_Glob2;
use  ZG_Glob2;
with ZG_Glob3;  
use  ZG_Glob3;
with ZG_Glob4;
use  ZG_Glob4;

with Calendar;
use  Calendar;

-->> Insert "with" clauses for required library units that you have added.

procedure ud_a%_user_def_ada%#_?? is

  pragma Suppress(Access_Check);
  pragma Suppress(Discriminant_Check);
  pragma Suppress(Index_Check);
  pragma Suppress(Length_Check);
  pragma Suppress(Range_Check);
  pragma Suppress(Division_Check);
  pragma Suppress(Overflow_Check);
  pragma Suppress(Elaboration_Check);
  pragma Suppress(Storage_Check);

  --
  -- Test Name         :  ud_a%_user_def_ada%#_??

  -- Prime Purpose     :  
  --                      
  -- Optimization      :  
  -- Related tests     :  
  -- Author            :  
  -- Date              :  
  -- Dependencies      :  
  -- Other Information :
  -- Revisions         :

-->> Insert test-specific declarations here.

begin -- ud_a%_user_def_ada%#_??

-->> Insert any necessary initialization code that is not to be included
-->> in the time measurement.

  ZG_Glob2.Put_Test_Name("ud_a%_user_def_ada%#_??");

  pragma Include("startime");  -- Top part of timing loop
  -- Code to time begins below

-->> Insert the code to be timed.

--:: If you wish to time the entire program, insert it at the beginning of
--:: the file and insert a call to it at this point.

  -- Code to time ends above
  pragma Include("stoptime0");  -- Bottom part of timing loop

--:: Code inserted here will not be included in the timing.

  pragma Include ( "Stoptime2" );  -- Timing report

end ud_a%_user_def_ada%#_??;
