WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_eh_except_handl_03 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  excp : EXCEPTION;

  PROCEDURE f IS
  BEGIN
    zg_glob4.proc0;
    IF zg_glob4.ii > 0 THEN
      RAISE excp;
    END IF;
  END f;

BEGIN
  --
  -- Test Name         :  xh_eh_except_handl_03
  -- Prime Purpose     :  Block with exception handler which calls on a
  --                      procedure which raises the exception (the procedure
  --                      it calls on does not have a handler but simply 
  --                      raises the exception.)
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :  xh_eh_except_handl_06
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Thomas M. Lee
  -- Date              :  October 10, 1989
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 

  zg_glob4.ii := 100;     -- this causes exception to be raised
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_eh_except_handl_03");
  PRAGMA include("startime");
  DECLARE
  BEGIN
    zg_glob4.xx := zg_glob4.one;
    f;
  EXCEPTION
    WHEN excp =>
      NULL;
    WHEN OTHERS =>
      zg_glob4.die;
  END;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   DECLARE  BEGIN  xx:=one;  f;  EXCEPTION WHEN excp=>null;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "     WHEN others=>die;   END;");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------

END xh_eh_except_handl_03;  
