WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_er_except_raise_03 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  --
  -- Test Name         :  xh_er_except_raise_03
  -- Prime Purpose     :  define user-defined exception, do not raise it
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :  xh_er_except_raise_02, xh_en_except_num_err_01
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Thomas M. Lee
  -- Date              :  October 13, 1989
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
   
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_er_except_raise_03");
  PRAGMA include("startime");
  DECLARE                   -- cf xh_er_except_raise_02,xh_en_except_num_err_01
    except : EXCEPTION;
  BEGIN
    IF zg_glob4.ll < 0 THEN          -- false, except not raised
      RAISE except;
    END IF;
  EXCEPTION
    WHEN except =>
      zg_glob4.proc0;
  END;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
"   -- user defined exception declared not raised");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
"   -- cf xh_er_except_raise_02, xh_en_except_num_err_01");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------

END xh_er_except_raise_03 ;  
