WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

PACKAGE xh_pdpkg IS
 
  SUBTYPE name           IS string(1 .. 10);
  TYPE    marital_status IS (single, married);
  TYPE person(status : marital_status := single) IS RECORD
    given_name               : name;
    birth_year               : zg_glob1.integer16;
    CASE status IS
      WHEN married =>
        spouse_name          : name;
        number_of_dependents : zg_glob1.integer16;
      WHEN single =>
        next_of_kin          : name;
    END CASE;
  END RECORD;
  pat : person := (married, "mike      ", 1900, "pat       ", 2);
  mike : person:= (single, "patrick   ", 1950, "none      ");
 
  PROCEDURE proc_vector(vec : IN OUT zg_glob3.vector);
  PROCEDURE proc_record_reference(r : IN OUT person);
  PROCEDURE proc_t1_rec(r : IN OUT zg_glob4.t1_rec);
 
END xh_pdpkg;
 
PACKAGE BODY xh_pdpkg IS
 
  PROCEDURE proc_record_reference(r : IN OUT person) IS
  BEGIN
    NULL;
  END proc_record_reference;
 
  PROCEDURE proc_vector(vec : IN OUT zg_glob3.vector) IS
  BEGIN
    NULL;
  END proc_vector;
 
  PROCEDURE proc_t1_rec(r : IN OUT zg_glob4.t1_rec) IS
  BEGIN
    NULL;
  END proc_t1_rec;

END xh_pdpkg;
 
