WITH xh_pepkg07;
USE  xh_pepkg07;

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;

PACKAGE pkg01_xh_pe08 IS
  pragma Elaborate_Body;  -- Required by Ada 95.  PCR 2.32   DEC 94
 
                                  --  no objects or types are exported
END pkg01_xh_pe08;
 
PACKAGE BODY pkg01_xh_pe08 IS
  
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
 
  PRAGMA include("inittime"); --timing loop must be initialized here
 
  --
  -- Test Name         :  xh_pe_prgma_sup_elab_ck_08
  -- Prime Purpose     :  Version of xh_pe_prgma_sup_elab_ck_03 which 
  --                      specified suppression of predefined constraint
  --                      checking.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :  xh_pe_prgma_sup_elab_ck_*
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_pe_prgma_sup_elab_ck_08");
  PRAGMA include("startime");
  BEGIN
       xh_pepkg07.elab_07;
       xh_pepkg07.elab_07;
       xh_pepkg07.elab_07;
       xh_pepkg07.elab_07;
    IF zg_glob4.ll /= zg_glob4.mm THEN    -- always true
       xh_pepkg07.elab_07;
    END IF;
  EXCEPTION
    WHEN program_error =>
      zg_glob4.die;
  END;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   --suppress checking version of xh_pe_prgma_sup_elab_ck_03 ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 
END pkg01_xh_pe08;
----------------------------------
 
WITH pkg01_xh_pe08;
USE  pkg01_xh_pe08;
PRAGMA elaborate(pkg01_xh_pe08);
 
PROCEDURE xh_pe_prgma_sup_elab_ck_08 IS
BEGIN
  NULL;    -- the actual test problem is contained in the package body
END xh_pe_prgma_sup_elab_ck_08;
