WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_pi_prgma_sup_index_ck_01 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  --
  -- Test Name         :  xh_pi_prgma_sup_index_ck_01
  -- Prime Purpose     :  Reference to subscripted array of integer16, 
  --                      no checking. 
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :  dr_ao_array_oper_01
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Thomas M. Lee
  -- Date              :  October 9. 1989
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --

  --------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_pi_prgma_sup_index_ck_01");
  PRAGMA include("startime");
  zg_glob4.ii := zg_glob4.i1(zg_glob4.ei);
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   ii := i1 ( ei );  -- cf dr_ao_array_oper_01");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  --------------------------------------------------------------------------

END xh_pi_prgma_sup_index_ck_01 ;  
